
! hlts during xmit startup... squeeze delays.
!----------------------------------------------------------------------
!
!  NOKIA MOBIRA TMx-1 phones (some, at least, maybe)
!
!  Fri Mar 10 20:37:43 EET 2000
!  Juha Nurmela
!
!  uPD7810 CPU
!  MB1501 or MB87006 PLLs
!  MAS 7845 LFU
!  MC144111 6bit DAC
!  i8253 timer
!  what else
!  and other misc fluff
!
!  Usable (maybe) with companion handset HSN2 on MBUS
!
#define VERSION_1 "TMx1 0.9"
#define VERSION_2 "10.3.000"
!                  12345678

!----------------------------------------------------------------------
!
!
#define MBUSID "TMx1"

#define HS_ID "HSN2"

!----------------------------------------------------------------------
!

!----------------------------------------------------------------------
!
!  portpins
!
!  PA
!
SCL    = 0x01 ! output synth, eeprom, D/A, LFU
SDA    = 0x02 ! in/out synth, eeprom, D/A, LFU (this isnt the i2c data ? XXX)
TSLG   = 0x04 ! output tx synth loopgain, "1" = slow, "0" = fast
DATA   = 0x08 ! in/out XXX
LFUSTB = 0x10 ! output LFU strobe
CRM    = 0x20 ! output car radio mute
EXTA   = 0x40 ! output external alert
DTC    = 0x80 ! output Pavel says: PTT input. Okay.
!
!  PB
!
SD68   = 0x01 ! output 6/8V portable/car
TSEN   = 0x02 ! output tx synth enable pulse
RSEN   = 0x04 ! output rx synth enable pulse
PB3_NC = 0x08 ! no connection ? XXX
TXON   = 0x10 ! output tx supply "1"
TSON   = 0x20 ! output tx synth supply "1"
TAON   = 0x40 ! output tx audio supply "1"
EEOFF  = 0x80 ! output eeprom supply, "0" to enable
!
!  PC
!
! PC0  = TXD output
! PC1  = RXD input
I2DA   = 0x04 ! in/out I2C data. Set as in with MC; out with PC&MC
PAGE   = 0x08 ! output select eprom page at 0x8000, 1=flip from 0xC000
DADIS  = 0x10 ! output D/A enable, low active, thus DA DISABLE
! PC5  = CI input (aka netfree)
WDCLR  = 0x40 ! output watchdog clear, 2usec every 100msec says authotrity
PWROFF = 0x80 ! output power-off telephone
!
!  A/D inputs
!
! AN0 FSKL
! AN1 BCR  battery current
! AN2 BTMP battery temperature
! AN3 RSSI
! AN4 PFB  power feedback
! AN5 BATT +12V
! AN6 TEMP ambient temperature
! AN7 TIMEOUT (huh ?)
!
!  chipselects
!
MENA  = 0xC000 ! modem
TENA  = 0xC400 ! i8253 timer
SISE  = 0xC800 ! Sis processor ?
AMULE = 0xD400 ! AMU/LE (deviation latch) 3 LSbits control mod. 74259. D0 A0..2
!
!----------------------------------------------------------------------
!
!  output latch on audio module, 74259, A2..0 and D0
!

!----------------------------------------------------------------------
!
!  Datatypes the menu supports
!
CFG_NOTYPE = 0
CFG_FREQ   = 1
CFG_FOFF   = 2
CFG_TAB    = 3
CFG_DIGIT  = 4
CFG_BYTE   = 5
CFG_MSEC   = 6
CFG_SEC    = 7
CFG_MINUTE = 8
CFG_STRING = 9
CFG_DYN    = 10
CFG_RST    = 11
CFG_EXEC   = 12       ! XXX no functionality yet
CFG_HELP   = 13 

CFG_CONSTANT = 0x80 ! ORed into type

!----------------------------------------------------------------------
!
!  external RAM 8192 bytes
!  stack is located at the end of the ram.
!  Remember, workarea only 256 bytes (V.wa)
!  DO NOT CHANGE V from workarea !

	.data
	.org 0xE000
ram:
!----------------------------------------------------------------------
!
!  Configurable data. Keep each variable name and .rs on one row.
!
#define SIZE_FREQ 3 /* 24 bits for binary freq in kHz */
#define SIZE_MSEC 2 /* millisecs as a word */

!= start of nonvolatile area ==========================================
cfg_start_area:

	cfg_XXX_0:          .rs 4
	cfg_XXX_1:          .rs 4
	cfg_XXX_2:          .rs 4
	cfg_XXX_3:          .rs 4

	cfg_alertvol:       .rs 1
	cfg_autoscan_time:  .rs 1
	cfg_callfreq:       .rs SIZE_FREQ
	cfg_ccir_idx:       .rs 1
	cfg_chan_step:      .rs 1 ! table of 25, 20, 12.5 or 10
	cfg_dtmf_idx:       .rs 1
	cfg_duplex_dir:     .rs 1
	cfg_duplex_off:     .rs SIZE_FREQ
	cfg_if_dir:         .rs 1 ! table of above, below
	cfg_if_freq:        .rs SIZE_FREQ
	cfg_keyclick:       .rs 1
	cfg_pin_code:       .rs 8
	cfg_pin_type:       .rs 1
	cfg_mic_gain:       .rs 1
	cfg_mic_src:        .rs 1
	cfg_my_favorite:    .rs SIZE_FREQ
	cfg_onhook_act:     .rs 1
	cfg_mycall:         .rs 8
	cfg_my_mbusid:      .rs 4
	cfg_reject_0:       .rs SIZE_FREQ
	cfg_reject_1:       .rs SIZE_FREQ
	cfg_reject_2:       .rs SIZE_FREQ
	cfg_reject_3:       .rs SIZE_FREQ
	cfg_reject_4:       .rs SIZE_FREQ
	cfg_reject_5:       .rs SIZE_FREQ
	cfg_reject_6:       .rs SIZE_FREQ
	cfg_reject_7:       .rs SIZE_FREQ
	cfg_reject_8:       .rs SIZE_FREQ
	cfg_reject_9:       .rs SIZE_FREQ
	cfg_rptr_area_high: .rs SIZE_FREQ
	cfg_rptr_area_low:  .rs SIZE_FREQ
	cfg_rxband_high:    .rs SIZE_FREQ
	cfg_rxband_low:     .rs SIZE_FREQ
	cfg_freq_implied:   .rs SIZE_FREQ
	cfg_sc1_high:       .rs SIZE_FREQ
	cfg_sc1_low:        .rs SIZE_FREQ
	cfg_sc2_high:       .rs SIZE_FREQ
	cfg_sc2_low:        .rs SIZE_FREQ
	cfg_sc3_freq_0:     .rs SIZE_FREQ
	cfg_sc3_freq_1:     .rs SIZE_FREQ
	cfg_sc3_freq_2:     .rs SIZE_FREQ
	cfg_sc3_freq_3:     .rs SIZE_FREQ
	cfg_scan_delay:     .rs 1
	cfg_scan_patience:  .rs 1
	cfg_sqdelay:        .rs SIZE_MSEC
	cfg_sqhyst:         .rs 1
	cfg_sqlevel:        .rs 1
	cfg_sqtail:         .rs SIZE_MSEC
	cfg_step_rate:      .rs SIZE_MSEC
	cfg_txband_high:    .rs SIZE_FREQ
	cfg_txband_low:     .rs SIZE_FREQ
	cfg_txpwr:          .rs 1

	cfg_txtone1:        .rs 8
	cfg_txtone2:        .rs 8
	cfg_txtone3:        .rs 8
	cfg_txtone4:        .rs 8
	cfg_txtone5:        .rs 8
	cfg_txtone6:        .rs 8
	cfg_txtone7:        .rs 8
	cfg_txtone8:        .rs 8

	cfg_afc:            .rs 1
	cfg_deviation:      .rs 1
	cfg_lfu_vol:        .rs 1

cfg_end_area:

	.org ram + 2048 - 4 * 100
memories:                    ! first 3 bytes for freq, then byte for misc flags

	.org ram + 2048          ! 2 kB for config and memories
end_memories:

workarea: ! XXX cook up some macros to give "safety" with LO(var)

volume:       .rs 1
rx_freq:      .rs SIZE_FREQ
tx_freq:      .rs SIZE_FREQ
duplex_state: .rs 1

scan_mode:      .rs 1
scan_mode_last: .rs 1

end_nonvolatile: !=========================================================

tx_on:       .rs 1

vco_freq:    .rs SIZE_FREQ
rx_div:      .rs 3
tx_div:      .rs 3

tx_pinned:   .rs 1  ! xmit frequency is pinned down, separate from rx.

dac_BCON:    .rs 1
lfu_regs:    .rs 4  ! All 4.
rssi:        .rs 1
rssi_prev:   .rs 1
rssi_peak:   .rs 1
sqopen:      .rs 1
sq_forced:   .rs 1
timer_rssi:  .rs 1
timer_sq:    .rs 1

curr_chr:    .rs 1
prev_chr:    .rs 1
kbd_flags:   .rs 1
 SHIFT   = 1
 ALPHA   = 2
 KEYLOCK = 4

alpha_idx:   .rs 1
kbd_index:   .rs 1
kbd_buffer:  .rs 8
prt_buffer:  .rs 16 ! scratch for printouts

timer_ticks:     .rs 1
timer_kbd_idle:  .rs 1

menu_active: .rs 1 ! bool
menu_ptr:    .rs 2 ! current record in menu, top or sub
menu_topptr: .rs 2 ! toplevel ptr, recall when rising

	ASSERT(. <= workarea + 256)

#include "mbus.asm" /* get the variables */

	.org 0xFFFE
stack:

!----------------------------------------------------------------------
!
!
!
	.text
!--------------------
	.org 0x0000     ! /RESET
	di
	jmp _start

!--------------------
	.org 0x0004     ! /NMI - restart
	jmp 0

!
!  Flags are not tested when entrypoints
!  have only one unmasked source.
!  The flag will be automatically cleared (when vectoring ?).
!
!--------------------
	.org 0x0008     ! INTT1 - 112 Hz (INTT0 not used)
	jmp systick

!--------------------
	.org 0x0010     ! INT1 /INT2
	ei
	reti

!--------------------
	.org 0x0018     ! INTE0 - timer/event counter, NETFREE indication
	jmp netfree

!--------------------
	.org 0x0020     ! INTEIN INTAD - CI/TO edge, A/D complete (unused)
	ei
	reti

!--------------------
	.org 0x0028     ! INTST INTSR - serial port (both interrupts unmasked)
	jmp serint

	ASSERT(. <= 0x0060) ! catch overrun
!--------------------
	.org 0x0060     ! SOFTI - software interrupt (might be used)
	reti

!----------------------------------------------------------------------
!
!  Call table
!
#define CALT_REC(x) tab_/**/x = (. - 0x0080) / 2; .word x;
	ASSERT(. <= 0x0080) ! catch overrun
!--------------------
	.org 0x0080

	ASSERT(. <= 0x00C0) ! End of call table

!----------------------------------------------------------------------
!
!  interrupt functions, no register saved yet
!

systick:
	ori PC, WDCLR
	exa

	mov A, [timer_ticks]
	sui A, 1
	aci A, 0
	mov [timer_ticks], A          ! crawls to 0, from max 255

	mov A, [timer_rssi]
	sui A, 1
	aci A, 0
	mov [timer_rssi], A          ! crawls to 0, from max 255

	mov A, [timer_kbd_idle]
	adi A, 1
	sbi A, 0
	mov [timer_kbd_idle], A      ! crawls to 255

	mov A, [timer_sq]
	gti A, 1
	?jr 1f
	sui A, 1
	mov [timer_sq], A            ! stays at 0, crawls to 1, from max 255
1:
	ani PC, ~WDCLR
	exa
	ei
	reti

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  STARTUP
!

_start:

	mvi A, 0
	mov MM, A       ! will just use the external RAM
	lxi SP, stack
	mvi V, HI(workarea) ! DO NOT CHANGE V from workarea

	lxi HL, end_nonvolatile      ! past memories and config.
	lxi EA, 0
	mvi A, 0
1:
	stax [HL]+               ! clear
	deq EA, HL
	?jr 1b

	call cpu_init
	call mbus_init

	call enable_ints
	ei

	jmp main

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  SYNTHESIZERS
!
!  By adding some extra bits,
!  this works on both MB87006 and MB1501 PLLs.

!
!  Preparation. Once only.
!  XXX set 10.0 kHz separation during 10 and 20 kHz ChStep
!  and 12.5 too ! XXX
!

synth_init:
	lxi EA, (0 << 14) | 512   ! Prescaler 128/129 (only MB1501), 25 kHz
	call synth_word
	mvi A, 0xFF
	call synth_bit            ! C=1

	ori PB, TSEN | RSEN
	nop
	nop
	ani PB, ~(TSEN | RSEN)    ! end pulse. configured both.
	ret

synth_receive:
	mov A, [rx_div + 2]
	call synth_byte       ! actually only 2 LSbits used ever
	mov A, [rx_div + 1]
	call synth_byte
	mov A, [rx_div + 0]
	call synth_byte
	mvi A, 0x00
	call synth_bit        ! C=0

	ori PB, RSEN
	nop
	nop
	ani PB, ~RSEN
	ret

synth_xmit:
	call synth_init       ! too bad.

	mov A, [tx_div + 2]
	call synth_byte       ! actually only 2 LSbits used ever
	mov A, [tx_div + 1]
	call synth_byte
	mov A, [tx_div + 0]
	call synth_byte
	mvi A, 0x00
	call synth_bit        ! C=0

	ori PB, TSEN
	nop
	nop
	ani PB, ~TSEN
	ret

synth_word:
	mov A, EAH
	call synth_byte
	mov A, EAL

synth_byte:
	call 1f ; call 1f; call 1f; call 1f
	call 1f ; call 1f; call 1f

synth_bit:
1:
	sllc A
	?ani PA, ~SDA
	skn CY
	?ori PA, SDA
	nop
	nop
	ori PA, SCL      ! rising edge seems the active one
	nop
	nop
	ani PA, ~SCL
	ret

!
!  Refresh divisors and align back frequencies (into their effective values)
!
! XXX 12.5, and 10 are what we need

freq_changed:
	neiw LO(sq_forced), 0    ! sq NOT forced.
	?call squelch_now_closed

	! RX part

	call determine_rx_vco

	lxi HL, vco_freq
	mvi B, 25
	lxi DE, rx_div
	call divide_freq_by_B

	call synth_receive      ! receiver PLL updated here.

	lxi HL, rx_div
	mvi B, 25
	lxi DE, vco_freq
	call multiply_divisor_by_B

	call ocv_xr_enimreted

	! TX part (potentially in vain)

	call determine_tx_freq

	lxi HL, tx_freq
	mvi B, 25
	lxi DE, tx_div          ! for later use
	call divide_freq_by_B

	lxi HL, tx_div
	mvi B, 25
	lxi DE, tx_freq
	call multiply_divisor_by_B

	ret

ocv_xr_enimreted:

	lxi HL, vco_freq
	lxi BC, cfg_if_freq
	lxi DE, rx_freq

	mov A, [cfg_if_dir]
	eqi A, 0
	?jmp add_longs    
	jmp subtract_longs    ! normally, rx=vco-if


determine_rx_vco:

	lxi HL, rx_freq
	lxi BC, cfg_if_freq
	lxi DE, vco_freq

	mov A, [cfg_if_dir]
	eqi A, 0
	?jmp subtract_longs
	jmp add_longs        ! normally, vco=rx+if


! rx_freq or duplex_state has changed, what to do to tx_freq
! HL=rx, DE=tx, add, sub, copy what is needed

determine_tx_freq:

	lxi HL, rx_freq         ! generally in command of tx location
	lxi BC, cfg_duplex_off  ! increment/decrement maybe
	lxi DE, tx_freq

	mov A, [duplex_state]
	eqi A, 0
	?jr 1f
	jmp copy_freq           ! 0: DE=HL
1:
	eqi A, 1
	?jr 2f
	mov A, [cfg_duplex_dir]
	eqi A, 0
	?jmp add_longs
	jmp subtract_longs     ! 1: normally, DE=HL-BC
2:
	eqi A, 2
	?jr 3f
	mov A, [cfg_duplex_dir]
	eqi A, 0
	?jmp subtract_longs
	jmp add_longs          ! 2: normally, DE=HL+BC
3:
	ret         ! 3, tx and rx are unconnected. do nothing.


! fixups for flipping with R key

enter_reverse_duplex:
	lxi HL, rx_freq
	lxi BC, cfg_duplex_off
	lxi DE, rx_freq
	mov A, [cfg_duplex_dir]
	nei A, 0
	?call subtract_longs
	mov A, [cfg_duplex_dir]
	eqi A, 0
	?call add_longs
	ret

leave_reverse_duplex:
	lxi HL, rx_freq
	lxi BC, cfg_duplex_off
	lxi DE, rx_freq
	mov A, [cfg_duplex_dir]
	nei A, 0
	?call add_longs
	mov A, [cfg_duplex_dir]
	eqi A, 0
	?call subtract_longs
	ret

! Restore into duplex (2 to 1)

ok_with_reverse_duplex:
	call leave_reverse_duplex  ! 2 to 0 fixups
	mvi A, 1
	mov [duplex_state], A

	call freq_changed
	jmp redraw

set_duplex_wrt_freq: ! XXX
	mvi A, 0
	mov [duplex_state], A
	ret

!----------------------------------------------------------------------
start_xmit:
	mviw LO(tx_on), 1

	ani PA, ~TSLG
	ori PB, TSON          
	ori PA, EXTA
	call disconnect_audio  ! enough delay for the txpll to wakeup ?
	call synth_xmit

	call draw_currfreq     ! enough delay for the txpll to lock ?
	ori PB, TXON
	ori PA, TSLG
	ret

stop_xmit:
	mviw LO(tx_on), 0

	ani PB, ~TXON
	ani PA, ~EXTA
	call synth_receive
	call draw_currfreq     ! delay
	ani PB, ~TSON

	oniw LO(sq_forced), 1
	?call squelch_now_closed
	offiw LO(sq_forced), 1
	?call connect_audio
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  MC144111 DAC
!
!  Defaults
!
DAC_init:
	mvi A, 0x7F         ! 6bit value will be 1F (half of max 3F)
	mov [dac_BCON], A

	jmp DAC_update

DAC_update:
	ani PC, ~DADIS

	! cfg_afc is byte, just use 6 MSbits

	mov A, [cfg_afc]
	call DAC_byte

	mov A, [dac_BCON]
	call DAC_byte

	mov A, [cfg_txpwr]
	lti A, 64
	?jr 1f

	! cfg_txpwr is byte, less than 64 is fine only, else coarse
	! (makes sense ? Youll want finer adjustment for milliwatts ?)

	mvi A, 0
	call DAC_byte       ! coarse 0
	mov A, [cfg_txpwr]
	sll A
	sll A
	call DAC_byte       ! fine from configged byte (all 0...63 values valid)
	jr 2f
1:
	mov A, [cfg_txpwr]
	call DAC_byte       ! coarse as wanted (only top 6 bits are valid)
	mvi A, 0xFF
	call DAC_byte       ! fine helps as much it can.
2:
	ori PC, DADIS
	ret

! send 6 MSbits

DAC_byte:
	call 1f; call 1f; call 1f;    ! 3 bits
	call 1f; call 1f              ! 2 bits, and FALLTHRU for last.

DAC_bit:
1:
	sllc A
	?ani PA, ~SDA
	skn CY
	?ori PA, SDA
	nop
	nop
	ori PA, SCL
	nop
	nop
	ani PA, ~SCL      ! falling edge seems the active one for DAC
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  LFU
!

LFU_init:
	! FSKT 00 bit 3    connect transmitted data
	! FSKE 00 bit 4    connect received data
	! TXP  00 bit 5    supply to tx parts and 4kHz filter
	mvi A, 0b100000 | 0x00
	mov [lfu_regs + 0], A

	! VOL  01 bit 3..0 rx audio volume
	! SPK  01 bit 4    rx audio connect
	mov A, [cfg_lfu_vol]
	ani A, 0xF
	ori A, 0b010000 | 0x40
	mov [lfu_regs + 1], A

	! H    10 bit 2    rx audio connect
	! RXP  10 bit 3    rx parts supply
	! COME 10 bit 4    compander enable
	! MICO 10 bit 5    cutoff mic (during fsk) XXX "1" or "0" cuts ? aka TXDE ?
	mvi A, 0b101100 | 0x80
	mov [lfu_regs + 2], A

	! S    11 bit 0    connect mic
	! AGCE 11 bit 3    tx audio agc enable
	! SVE  11 bit 4    connect supervisory signal loopback
	mvi A, 0b001001 | 0xC0
	mov [lfu_regs + 3], A

	jmp update_LFU

connect_audio:
	mov A, [lfu_regs + 1]
	ori A, 0b010000
	! SPK  01 bit 4    rx audio connect
	jr 1f
disconnect_audio:
	mov A, [lfu_regs + 1]
	ani A, ~0b010000
1:
	mov [lfu_regs + 1], A

	jmp update_LFU_one

update_LFU:
	mov A, [lfu_regs + 0]
	call update_LFU_one

	mov A, [lfu_regs + 1]
	call update_LFU_one

	mov A, [lfu_regs + 2]
	call update_LFU_one

	mov A, [lfu_regs + 3]
	call update_LFU_one
	ret

update_LFU_one:
	call 1f ; call 1f; call 1f; call 1f
	call 1f ; call 1f; call 1f; call 1f
	ori PA, LFUSTB
	nop
	nop
	ani PA, ~LFUSTB    ! end pulse
	ret
1:
	sllc A
	?ani PA, ~SDA
	skn CY
	?ori PA, SDA
	nop
	nop
	ori PA, SCL      ! rising edge seems the active one
	nop
	nop
	ani PA, ~SCL
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  CPU configuration

cpu_init:

	mvi PA, DTC          ! off: EXTA, CRM, LFUSTB, DATA, TSLG, SDA, SCL
	mvi A, DTC
	mov MA, A            ! inputs 1 (DTC left as input input)

	mvi PB, EEOFF | TAON ! off: TSON, TAON, RSEN, TSEN, SD68
	mvi A, 0
	mov MB, A            ! inputs 1 (all outputs)

	mvi PC, 0x20 | DADIS | 0x02   ! off: PWROFF, WDCLR, PAGE, I2DA
	mvi A, 0x23                   ! CI,RXD,TXD special
	mov MCC, A
	mvi A, 0x20 | I2DA | 0x02     ! magics for CI and RXD
	mov MC, A            ! inputs 1

	mvi ANM, 0x00  ! XXX AN4..7 thru edge flags. 0..3 in scan mode.

	mvi TMM, 0x20  ! TMR0 run from f/12 into F/F, TMR1 run from f/384
	mvi A, 3
	mov TM0, A     ! 921.6 kHz, to generate serial 9600 bd for MBUS
	mvi A, 0xFF
	mov TM1, A     ! to generate 112 Hz systick (will use like 100 Hz)

	mvi A, 0x5E
	mov SML, A     ! 1stop, odd parity, 8bits, x16 clock
	mvi A, 0
	mov SMH, A     ! flush
	mvi A, 0x0C
	mov SMH, A     ! rx enable, tx enable, internal TO clock

	ori PC, WDCLR
	
	skit INTFST    ! flush tx
	?nop
	skit INTFSR    ! flush rx
	?nop
	skit ER        ! flush rx
	?nop
	mov A, RXB
	mov A, RXB
	mov A, RXB
	skit INTFST    ! flush tx
	?nop
	skit INTFSR    ! flush rx
	?nop
	skit ER        ! flush rx
	?nop

	mvi A, 0
	mov EOM, A     ! not interested at PWM capabilities

	mvi A, 0x08
	mov ETMM, A    ! clear ECNT at CI falling edge, internal f/12 clock
	lxi EA, 1843
	dmov ETM0, EA  ! 921.6 kHz / ETM0 = 500 Hz, about 20 mbus chars.

	ani PC, ~WDCLR

	ret

enable_ints:

	ani MKL, ~0x24 ! INTE0, INTT1
	ani MKH, ~0x06 ! INTST, INTSR

	skit INTFT1
	?nop
	skit INTFE0
	?nop
	skit INTFST
	?nop
	skit INTFSR
	?nop

	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  Audio stuff
!

vol_mute:
	mvi A, 0
	mov [volume], A
	jmp vol_set

vol_inc:
	mov A, [volume]
	adi A, 1
	lti A, 9
	?mvi A, 9
	mov [volume], A
	jmp vol_set

vol_dec:
	mov A, [volume]
	sui A, 1
	aci A, 0
	lti A, 9
	?mvi A, 9
	mov [volume], A
	jmp vol_set

vol_set:
	call redraw
	jmp mbus_sendvol

!----------------------------------------------------------------------
!----------------------------------------------------------------------

redraw:
	mov A, [menu_active]
	eqi A, 0
	?jmp draw_menu

	call draw_top_row
	jmp draw_kbd_buffer

! Something like
!
! "??? SQ V"
! "D 434775"

draw_top_row:
	lxi HL, prt_buffer

	mvi A, ' '
	stax [HL]+
	stax [HL]+
	stax [HL]+

	mvi A, ' '
	stax [HL]+

	mov A, [cfg_sqlevel]
	lxi EA, 0
	mov EAL, A
	mvi B, 10
	div B
	mov A, EAL
	adi A, '0'
	eqiw LO(sq_forced), 0
	?mvi A, 'S'
	stax [HL]+
	mov A, B
	adi A, '0'
	eqiw LO(sq_forced), 0
	?mvi A, 'Q'
	stax [HL]+

	mvi A, ' '
	stax [HL]+

	mov A, [volume]
	adi A, '0'
	stax [HL]+

	mvi C, 8
	lxi HL, prt_buffer
	jmp mbus_send_upper

draw_bottom_row:
	eqiw LO(scan_mode), 0
	?jmp draw_scan_mode

	jmp draw_currfreq

draw_scan_mode:
	lxi HL, 1f
	mvi C, 8
	jmp mbus_send_lower
1:
	.ascii "SCAN  14"

draw_currfreq:
	lxi HL, rx_freq
	offiw LO(tx_on), 1
	?lxi HL, tx_freq

	ldeax [HL]
	ldax [HL+2]
	mov B, A
	lxi HL, prt_buffer
	call i2buf
	mov A, [duplex_state]
	nei A, 0
	?jr 1f
	nei A, 1
	?mvi A, 'D'
	nei A, 2
	?mvi A, 'R'
	nei A, 3
	?mvi A, 'X'
	gti A, ' '
	?mvi A, '?'
	mov [prt_buffer + 0], A
1:
	lxi HL, prt_buffer
	mvi C, 8
	jmp mbus_send_lower

draw_kbd_buffer:
	mov C, [kbd_index]
	nei C, 0
	?jmp draw_bottom_row    ! No value under edit. Show default bottom row

	lxi HL, kbd_buffer
	lxi DE, prt_buffer
	jr 2f
1:
	ldax [HL]+
	stax [DE]+
2:
	dcr C
	?jr 1b
	mvi C, 8
	mov A, [kbd_index]
	sub C, A
	jr 2f
1:
	mvi A, ' '
	stax [DE]+
2:
	dcr C
	?jr 1b
	lxi HL, prt_buffer
	mvi C, 8
	jmp mbus_send_lower

format_EA:
	lxi HL, prt_buffer + 5
	mvi C, 4
1:
	dcx HL
	mvi A, 10
	div A
	adi A, '0'
	stax [HL]
	dcr C
	?jr 1b

	mvi C, 3 ! blank out at max 4 leading zeroes
1:
	ldax [HL]
	eqi A, '0'   ! leading zero.
	?jr 1f
	mvi A, ' '
	stax [HL]+
	dcr C
	?jr 1b       ! 4 times max.
1:
	ret

fcn_off:
	push VA
	mov A, [kbd_flags]
	ani A, ~SHIFT
	mov [kbd_flags], A ! clear shifted state

	call mbus_update_lights
	pop VA
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
!
!  New keyboard press in A, B nz if typematic
!
got_key:
	mov C, [curr_chr]
	mov [prev_chr], C
	mov [curr_chr], A

	mov C, [timer_kbd_idle]
	mviw LO(timer_kbd_idle), 0

	nei A, 'Q'
	?jmp do_quit
	nei A, 'P'
	?jmp do_ptt

	! other input ignored during xmit

	eqiw LO(tx_on), 0
	?ret

	nei A, '+'
	?jmp do_plus
	nei A, '-'
	?jmp do_minus_or_mute
	nei A, 'M'
	?jmp do_mute

	nei A, 'C'
	?jmp do_clear

	nei A, 'F'
	?jmp do_fcn
	nei A, 'A'
	?jmp do_r_alpha

	nei A, '?'
	?jmp do_menu_mft
	nei A, 'O'
	?jmp do_ok_lock
	nei A, 'N'
	?jmp do_next_prev
	nei A, 'R'
	?jmp do_rcl_sto

	nei A, '#'
	?jmp do_enter
	nei A, '*'
	?jmp do_star

	nei A, 'E'
	?jmp do_handset
	nei A, 'H'
	?jmp do_hf

	! all that is left are the digits

	offiw LO(kbd_flags), ALPHA
	?jmp alpha_input             ! ALPHA was not off, go.

chr_input:                 ! re-entry for specials as regulars

	mov B, [kbd_index]
	lti B, 8
	?ret

	lxi HL, kbd_buffer
	stax [HL+B]
	adi B, 1
	mov [kbd_index], B

	eqiw LO(menu_active), 0
	?jmp menu_input       ! Maybe it will want to touch the buffer

	jmp draw_kbd_buffer

alpha_tab:
	.ascii "[\\]0ABC1DEF2GHI3JKL4MNO5PQR6STU7VWX8YZ-9"

alpha_input:
	mov B, [kbd_index]
	nei B, 0
	?mviw LO(alpha_idx), 0 ! first chr, rewind ABC to 'A'
	lti C, 150
	?mviw LO(alpha_idx), 0 ! second of idle, rewind ABC to 'A'
	eqaw LO(prev_chr)
	?mviw LO(alpha_idx), 0 ! different key

	eqaw LO(prev_chr)
	?jr 1f        ! different key
	nei B, 0
	?jr 1f        ! no character
	lti C, 150
	?jr 1f        ! interval over 1 sec
	sui B, 1               ! rewind over the changing character
1:
	lti B, 8
	?mvi B, 8 - 1   ! last chr cell is problematic....

	mov C, [alpha_idx]

	lxi HL, alpha_tab
	sui A, '0'
	sll A
	sll A ! *= 4
	add A, C
	ldax [HL+A]

	lxi HL, kbd_buffer
	stax [HL+B]
	adi B, 1
	lti B, 8
	?mvi B, 8
	mov [kbd_index], B

	adi C, 1
	lti C, 4
	?mvi C, 0
	mov [alpha_idx], C

	call draw_kbd_buffer
	ret


!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!
!

scan_stop:
	mov A, [scan_mode]
	mov [scan_mode_last], A
	mvi A, 0
	mov [scan_mode], A

	jmp redraw

scan_start:
	mov A, [scan_mode_last]
	nei A, 0
	?mvi A, 1                  ! no previous mode, default mask 1

	mov [scan_mode], A
	mov [scan_mode_last], A

	mviw LO(kbd_index), 0
	jmp redraw

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  MAIN
!
main:

	mvi A, 200
	call pause       ! twiddle here around 2 seconds

	! Go on.

	call mbus_hello
	call handset_init

	call menu_init
	call synth_init
	call LFU_init
	call DAC_init
	call freq_changed
	call disconnect_audio

	mvi A, 200
	call pause     ! twiddle again

	call redraw
	call mbus_sendrssi
	call squelch_now_closed

mainloop:

	call mbus_process

	eqiw LO(tx_on), 0
	?jr mainloop

	! only during receive

	call read_rssi           ! before below 3 ones
	call squelch
	call check_rssi_display
	call check_dynamic_menu

	jmp mainloop

pause:
	staw LO(timer_ticks)
1:
	eqiw LO(timer_ticks), 0
	?jr 1b
	ret

!----------------------------------------------------------------------
squelch:
	offiw LO(sq_forced), 1
	?ret
	mov A, [sqopen]
	eqi A, 0
	?jmp squelch_is_open
	jmp squelch_is_closed

squelch_is_closed:
	mov A, [cfg_sqlevel]
	mov B, [cfg_sqhyst]
	slr B               ! halve
	add A, B            ! use level + 1/2 hyst
	skn CY
	?mvi A, 0xFF
	mov B, [rssi]
	lta A, B
	?jmp 1f             ! ?Not. below lower limit. definitely closed.
	mov A, [timer_sq]
	nei A, 1
	?jmp squelch_now_open ! at 1, timeout
	eqi A, 0
	?ret                ! already timing.
	jmp start_sqdelay
1:
	mvi A, 0
	mov [timer_sq], A   ! stay closed.
	ret

start_sqdelay:
	lxi HL, cfg_sqdelay
	ldeax [HL]
	mvi A, 10
	div A
	mov A, EAL
	nei A, 0
	?jmp squelch_now_open ! no open delay
	mov [timer_sq], A
	ret

start_sqtail:
	lxi HL, cfg_sqtail
	ldeax [HL]
	mvi A, 10
	div A
	mov A, EAL
	nei A, 0
	?jmp squelch_now_closed ! no open delay
	mov [timer_sq], A
	ret

squelch_is_open:
	mov A, [cfg_sqlevel]
	mov B, [cfg_sqhyst]
	slr B               ! halve
	sub A, B            ! use level - 1/2 hyst
	skn CY
	?mvi A, 0
	mov B, [rssi]
	gta A, B
	?jmp 1f             ! ?Not. above upper limit. definitely open.
	mov A, [timer_sq]
	nei A, 1
	?jmp squelch_now_closed ! at 1, timeout
	eqi A, 0
	?ret                ! already timing.
	jmp start_sqtail
1:
	mvi A, 0
	mov [timer_sq], A   ! stay open.
	ret

squelch_now_closed:
	mvi A, 0
	mov [sqopen], A
	mvi A, 0
	mov [timer_sq], A
	jmp disconnect_audio

squelch_now_open:
	mvi A, 1
	mov [sqopen], A
	mvi A, 0
	mov [timer_sq], A
	jmp connect_audio

sq_override:
	mov A, [sq_forced]
	xri A, 1
	mov [sq_forced], A
	oniw LO(sq_forced), 1
	?call squelch_now_closed
	offiw LO(sq_forced), 1
	?call connect_audio
	jmp draw_top_row

sq_inc:
	mviw LO(sq_forced), 0
	mov A, [cfg_sqlevel]
	adi A, 1
	sbi A, 0
	mov [cfg_sqlevel], A
	jmp draw_top_row

sq_dec:
	mviw LO(sq_forced), 0
	mov A, [cfg_sqlevel]
	sui A, 1
	aci A, 0
	mov [cfg_sqlevel], A
	jmp draw_top_row

	!  Either
	!   currently we have NO audio, but user suggests
	!   that squelch ought to be OPEN.
	!  Or
	!   currently we HAVE audio, but user suggests
	!   that squelch ought to be CLOSED.
sq_auto:
	mviw LO(sq_forced), 0
	mov A, [rssi_peak]
	mov B, [cfg_sqhyst]
	sll B
	eqiw LO(sqopen), 0
	?jr 1f
	sub A, B         ! sq level = peak rssi - 2 * hyst, when sq closed
	skn CY
	?mvi A, 0
	jr 2f
1:
	add A, B        ! sq level = peak rssi + 2 * hyst, when sq open
	skn CY
	?mvi A, 0xFF
2:
	mov [cfg_sqlevel], A
	jmp draw_top_row

!----------------------------------------------------------------------
check_rssi_display:
	mov A, [rssi]
	mov B, [rssi_peak]
	nea A, B
	?ret               ! same.
	lta A, B
	?jmp new_rssi      ! rssi has rised
	eqiw LO(timer_rssi), 0
	?ret               ! still timing last peak
	jmp new_rssi

new_rssi:
	mov [rssi_peak], A
	call mbus_sendrssi
	mvi A, 200
	mov [timer_rssi], A
	ret

read_rssi:
	mov A, [rssi]
	mov [rssi_prev], A
	mov A, CR3
	sui A, 30           ! XXX discard 30 steps from bottom
	skn CY
	?mvi A, 0
	mvi B, 100
	mul B
	mvi A, (255 - 30 - 30) ! XXX also discard 30 steps from top
	div A
	mov A, EAL
	lti A, 99
	?mvi A, 99
	mov [rssi], A
	ret
!----------------------------------------------------------------------

check_dynamic_menu:
	neiw LO(menu_active), 0
	?ret
	lhld [menu_ptr]
	ldax [HL+offset_type]
	eqi A, CFG_DYN
	?ret
	eqiw LO(timer_ticks), 0
	?ret
	call draw_menu_lower     ! CFG_DYN need constant update
	mviw LO(timer_ticks), 100
	ret

canada:
	lxi HL, 1f
	mvi C, 8
	jmp mbus_send_lower
1:
	.asciz "CANADA !"

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  SMALL UTILITIES
!

! For short number commands. Clear also the buffer.

get_the_number:
	mov C, [kbd_index]
	lxi HL, kbd_buffer
	call buf2i
	mvi A, 0
	mov [kbd_index], A
	mov A, EAL
	ret

!  Return 0 in BC without pending digits, else the number -1.
!  Buffer is also emptied.
!  used to multiply plain commands. (3 NEXT)

repeat_count:
	lxi BC, 0
	mov A, [kbd_index]
	nei A, 0
	?ret                  ! no digits, return 0
	mov C, A
	lxi HL, kbd_buffer
	call buf2i
	push EA
	pop BC                ! return number - 1
	eqi C, 0
	?sui C, 1
	mvi A, 0
	mov [kbd_index], A    ! zero out buffer
	ret

!  Divide frequency in [HL] (3 bytes) by B, e.g. freq / 25
!  Store result to [DE] (3 bytes), leave remainder in B

divide_freq_by_B:
	ldeax [HL+1]      ! freq 2 MSBytes
	mov A, B          ! divisor
	div A
	steax [DE+1]      ! EAH result 2 MSBytes
	ldeax [HL]
	mov EAH, A        ! freq LSByte and remainder from above
	div B             ! leaves remainder in B
	mov A, EAL        ! result LSByte
	stax [DE]         ! into place
	ret

!  Multiply divisor in [HL] (3 bytes) by B, e.g. divisor * 25
!  Store result (e.g. frequency) into [DE] (3 bytes)

multiply_divisor_by_B:
	push BC
	ldax [HL+2]       ! [2] MSByte
	mul B
	push EA
	ldax [HL+1]       ! [1] middle byte
	mul B
	push EA
	ldax [HL]         ! [0] LSByte
	mul B
	steax [DE]        ! store result LSByte
	mov A, EAH
	pop EA            ! get 2nd *
	eadd EA, A        ! CY valid
	steax [DE+1]      ! store result middle byte
	mov A, EAH
	pop BC            ! get 1st *
	adc A, C          ! CY used
	stax [DE+2]       ! store result MSByte
	pop BC
	ret

! destination DE, HL+BC
add_longs:
	push BC
	ldax [HL]
	addx [BC]
	stax [DE]
	inx BC
	ldax [HL+1]
	adcx [BC]
	stax [DE+1]
	inx BC
	ldax [HL+2]
	adcx [BC]
	stax [DE+2]
	pop BC
	ret

! destination DE, HL-BC
subtract_longs:
	push BC
	ldax [HL]
	subx [BC]
	stax [DE]
	inx BC
	ldax [HL+1]
	sbbx [BC]
	stax [DE+1]
	inx BC
	ldax [HL+2]
	sbbx [BC]
	stax [DE+2]
	pop BC
	ret

! skip-return if freq is not zero (e.g. testing if setup freqs are set)

skip_if_not_empty_freq:
	ldax [HL]
	eqi A, 0
	?rets
	ldax [HL+1]
	eqi A, 0
	?rets
	ldax [HL+2]
	eqi A, 0
	?rets
	ret

skip_if_different_freqs:
	push DE
	ldax [HL]
	subx [DE]
	eqi A, 0
	?jr 1f
	inx DE
	ldax [HL+1]
	subx [DE]
	eqi A, 0
	?jr 1f
	inx DE
	ldax [HL+2]
	subx [DE]
1:
	pop DE
	eqi A, 0
	?rets          ! skips if freqs are different
	ret

copy_freq:
	ldeax [HL]
	steax [DE]
	ldax [HL+2]
	stax [DE+2]
	ret

! input in HL & C (kept), result to BEA,
! nondigits in buffer are not handled (funny results).
! leading blanks are skipped, thou.

buf2i:
	push BC
	push DE
	push HL
	mvi B, 0
	lxi EA, 0    ! collect here
1:
	nei C, 0
	?jr 1f
	ldax [HL]
	eqi A, ' '
	?jr 1f
	inx HL
	sui C, 1
	jr 1b
1:
	jmp 2f       ! start loop below, for 0 length input
1:
	dmov DE, EA
	mov A, B     ! copy BEA into ADE
	dadd EA, DE
	adc A, B     ! * 2 (in AEA)
	dadd EA, DE
	adc A, B     ! * 3
	dadd EA, DE
	adc A, B     ! * 4
	dadd EA, DE
	adc A, B     ! * 5
	dmov DE, EA
	mov B, A     ! copy AEA into BDE
	dadd EA, DE
	adc B, A     ! * 10 complete in BEA
	ldax [HL]+
	sui A, '0'
	eadd EA, A
	aci B, 0     ! ones added
2:
	dcr C
	?jre 1b
	mov A, B
	pop HL
	pop DE
	pop BC
	mov B, A     ! BEA has integer
	ret

! input in BEA
! output to [HL]...[HL+7]
! regs destroyed

i2buf:
	mvi A,  10000000 / 65536
	lxi DE, 10000000 % 65536
	call 1f
	adi A, '0'
	stax [HL+0]              ! 1_______ 0x67697f  0_______ 0x00ffff
	mvi A,  1000000 / 65536
	lxi DE, 1000000 % 65536
	call 1f
	adi A, '0'
	stax [HL+1]              ! 16______ 0x0bdbff  00______ 0x00ffff
	mvi A,  100000 / 65536
	lxi DE, 100000 % 65536
	call 1f
	adi A, '0'
	stax [HL+2]              ! 167_____ 0x012d9f  000_____ 0x00ffff
	mvi A,  10000 / 65536
	lxi DE, 10000 % 65536
	call 1f     
	adi A, '0'
	stax [HL+3]              ! 1677____ 0x001c2f  0006____ 0x00159f
	mvi A, 10
	div A
	adi A, '0'
	stax [HL+7]              ! 1677___5           0006___5
	mvi A, 10
	div A
	adi A, '0'
	stax [HL+6]              ! 1677__15           0006__35
	mvi A, 10
	div A
	adi A, '0'
	stax [HL+5]              ! 1677_215           0006_535
	mov A, EAL
	adi A, '0'
	stax [HL+4]              ! 16777215           00065535

	mvi C, 6
2:
	ldax [HL]
	eqi A, '0'
	?jr 2f
	mvi A, ' '
	stax [HL]+
	dcr C
	?jr 2b
2:
	ret
1:
	mvi C, -1
1:
	adi C, 1
	dsub EA, DE
	sbb B, A
	sk CY
	?jr 1b
	dadd EA, DE
	adc B, A
	mov A, C
	ret

get_the_channel_step:
	mov A, [cfg_chan_step]
	mvi B, 25
	nei A, 1
	?mvi B, 20
	nei A, 2
	?mvi B, 12
	nei A, 3
	?mvi B, 10
	ret             ! kHz in B

step_channel_up:
	call get_the_channel_step
	ldeax [HL]
	ldax [HL+2]
	eadd EA, B
	aci A, 0
	steax [HL]
	stax [HL+2]
	ret

step_channel_down:
	call get_the_channel_step
	ldeax [HL]
	ldax [HL+2]
	esub EA, B
	sbi A, 0
	steax [HL]
	stax [HL+2]
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  Key specific actions
!
!----------------------------------------------------------------------

do_quit:
	ani PB, ~(TXON | TSON | TAON)

	mvi A, 100
	call pause

	ori PC, PWROFF
	jmp .

do_menu_mft:
	offiw LO(kbd_flags), SHIFT
	?jmp do_mft
	jmp do_menu

do_ok_lock:
	eqiw LO(menu_active), 0
	?jmp menu_ok               ! OK on menu overrides LOCK
	offiw LO(kbd_flags), SHIFT
	?jmp do_lock
	jmp do_ok

do_r_alpha:
	offiw LO(kbd_flags), SHIFT
	?jmp do_alpha
	jmp do_r

do_next_prev:
	eqiw LO(menu_active), 0
	?jmp menu_next_prev

	offiw LO(kbd_flags), SHIFT
	?jmp do_prev
	jmp do_next

do_rcl_sto:
	offiw LO(kbd_flags), SHIFT
	?jmp do_sto
	jmp do_rcl

!----------------------------------------------------------------------
do_clear:
	offiw LO(kbd_flags), SHIFT
	?jr 2f
	mov A, [kbd_index]
	dcr A
	?jr 1f
2:
	mvi A, 0
1:
	mov [kbd_index], A
	call fcn_off

	jmp redraw

do_plus:
	offiw LO(kbd_flags), SHIFT
	?jmp sq_inc
	jmp vol_inc

do_minus_or_mute:
	offiw LO(kbd_flags), SHIFT
	?jmp sq_dec
	eqi B, 0
	?jmp vol_mute    ! typematic -, mute instead (AND HURRY !)
	jmp vol_dec

do_mute:
	offiw LO(kbd_flags), SHIFT
	?jmp sq_auto
	jmp sq_override

do_mft:
	call fcn_off
	ret

do_ok:
	eqiw LO(kbd_index), 0
	?jmp do_enter_really         ! digits OK

	mov A, [duplex_state]
	nei A, 2
	?jmp ok_with_reverse_duplex ! OK during input monitoring

	jmp recall_my_favorites     ! plain OK


do_fcn:
	mov A, [kbd_flags]
	xri A, SHIFT
	mov [kbd_flags], A
	jmp mbus_update_lights

do_alpha:
	call fcn_off
	mov A, [kbd_flags]
	xri A, ALPHA
	mov [kbd_flags], A
	jmp mbus_update_lights

do_lock:
	call fcn_off
	mov A, [kbd_flags]
	xri A, KEYLOCK
	mov [kbd_flags], A
	jmp mbus_update_lights

do_rcl:
	ret

do_sto:
	call fcn_off
	ret

do_next:
	call repeat_count
1:
	push BC
	lxi HL, rx_freq
	call step_channel_up
	pop BC
	dcr C
	?jr 1b
	call set_duplex_wrt_freq
	call freq_changed
	jmp redraw

do_prev:
	call repeat_count
1:
	push BC
	lxi HL, rx_freq
	call step_channel_down
	pop BC
	dcr C
	?jr 1b
	call set_duplex_wrt_freq
	call freq_changed
	jmp redraw

!  duplex state might be 3, reset here to 0..2

do_r:
	mov A, [duplex_state]
	nei A, 1
	?call enter_reverse_duplex  ! 1 to 2 fixups
	mov A, [duplex_state]
	nei A, 2
	?call leave_reverse_duplex  ! 2 to 0 fixups

	mov A, [duplex_state]
	adi A, 1
	lti A, 3
	?mvi A, 0
	mov [duplex_state], A

	call freq_changed
	jmp redraw

do_star:
	offiw LO(kbd_flags), ALPHA
	?jmp chr_input             ! ALPHA was not off, go stash '*'

	eqiw LO(kbd_index), 0
	?jmp dtmf_from_buffer

	nei B, 0
	?jmp repeater_beep         ! once only

	ret

! PTT button. Sticky TX without real PTT ?

do_ptt:
	mov A, [tx_on]
	eqi A, 0
	?jmp stop_xmit
	jmp start_xmit


! Button with the small handset in it. Start scanner

do_handset:
	eqiw LO(scan_mode), 0      ! not already scanning.
	?jmp scan_stop

	jmp scan_start

do_hf:
	ret

do_enter:
	offiw LO(kbd_flags), ALPHA
	?jmp chr_input             ! ALPHA was not off, go stash '#'

do_enter_really:
	eqiw LO(menu_active), 0
	?call menu_accept

	neiw LO(menu_active), 0
	?call cmd_accept

	mviw LO(kbd_index), 0
	call redraw
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
cmd_accept:
	mov A, [kbd_index]
	gti A, 2
	?ret
	nei A, 3
	?jmp cmd_3_digits
	nei A, 4
	?jmp cmd_4_digits

	jmp cmd_frequency

!----------------------------------------------------------------------
!
cmd_3_digits:
	jmp prep_implied_first

cmd_4_digits:
	jmp prep_implied_first

cmd_5_digits:
	jmp prep_implied_first

cmd_frequency:
	lxi HL, kbd_buffer
	mov C, [kbd_index]
	jmp go_HLC_freq

go_HLC_freq:
	call buf2i
	lxi HL, rx_freq
	steax [HL]
	mov A, B
	stax [HL+2]

	call set_duplex_wrt_freq
	call freq_changed
	ret

prep_implied_first:
	lxi HL, cfg_freq_implied
	ldeax [HL]
	ldax [HL+2]
	mov B, A
	lxi HL, prt_buffer
	call i2buf                  ! prt_buffer has implied part of freq
	lxi DE, prt_buffer + 8
	lxi EA, kbd_buffer
	mov A, [kbd_index]
	eadd EA, A
	dmov HL, EA
	mov C, A                    ! overwrite from the end with kbd input
	jr 2f
1:
	dcx HL
	dcx DE
	ldax [HL]
	stax [DE]
2:
	dcr C
	?jr 1b
	lxi HL, prt_buffer
	mvi C, 8
	jmp go_HLC_freq

!----------------------------------------------------------------------
!
!
recall_my_favorites:
	lxi DE, rx_freq          ! what we will change
	lxi HL, cfg_callfreq
	call skip_if_different_freqs
	lxi HL, cfg_my_favorite
	call skip_if_not_empty_freq
	jmp do_enter_really

	call copy_freq
	call set_duplex_wrt_freq
	call freq_changed
	call redraw
	ret

!----------------------------------------------------------------------
1:
	.ascii "RRRRR"

repeater_beep:
	call start_xmit
	lxi HL, 1b
	mvi C, 4
	call mbus_send_tones
	mvi A, 50
	call pause
	call stop_xmit
	ret

dtmf_from_buffer:
	call start_xmit
	lxi HL, kbd_buffer
	mov C, [kbd_index]
	call mbus_send_tones
	mov A, [kbd_index]
	adi A, 1
	mvi B, 10
	mul B
	mov A, EAL
	call pause
	call stop_xmit

	mviw LO(kbd_index), 0  ! This will clear the buffer. Use PTT to keep it.
	ret

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  Configuration menu
!
!  - MENU enters/leaves menu (into last selected level and index)
!  - NEXT/PREV steps menu at the current level
!  - OK descends into current submenu from mainmenu level or 
!       ascends back to mainmenu level

menu_init:
	lxi HL, menu_main
	shld [menu_ptr]
	shld [menu_topptr]
	ret

do_menu:
	neiw LO(kbd_index), 0
	?jr 1f
	mvi A, 1
	mov [menu_active], A
	call menu_shortcut
	jmp redraw
1:
	mov A, [menu_active]
	xri A, 1
	mov [menu_active], A ! flip master in/out of menu switch.
	eqi A, 0
	?call menu_enter
	jmp redraw

! shortcut to numbered top record

menu_shortcut:
	call get_the_number
	mvi B, 16
	mul B                  ! offset (3 * 16) to EA
	lxi DE, menu_main
	lxi HL, end_menu_main - 16
	dadd EA, DE

	dlt EA, HL
	?dmov EA, HL
	dgt EA, DE
	?dmov EA, DE

	dmov HL, EA
	shld [menu_topptr]
	shld [menu_ptr]
	call menu_enter
	ret

! Process each keystroke maybe specially in submenu level
! Input character(s) are already in buffer
! We will do the lower row painting

menu_input:

	lhld [menu_ptr]
	ldax [HL+offset_type] ! type
	nei A, CFG_TAB
	?jmp menu_input_tab
	nei A, CFG_DIGIT
	?jmp menu_input_digit

	jmp draw_kbd_buffer            ! else dont care until #

menu_input_digit:
menu_input_tab:
	mov A, [kbd_index]
	gti A, 1              ! Another char, but only one allowed. overwrite 1st.
	?jr 1f
	mov A, [kbd_buffer + 1]
	mov [kbd_buffer], A
	mvi A, 1
	mov [kbd_index], A
1:
	jmp draw_menu_lower

menu_next_prev:
	call repeat_count
1:
	push BC
	call 1f
	pop BC
	dcr C
	?jr 1b
	call menu_enter
	jmp redraw
1:
	lxi EA, 16
	offiw LO(kbd_flags), SHIFT
	?lxi EA, -16         ! Next +1, Prev -1

	lhld [menu_ptr]
	ldax [HL+offset_type] ! are we stepping at top or sublevel
	dadd EA, HL           ! nudge new ptr into EA

	eqi A, CFG_NOTYPE     ! we are at toplevel.
	?jr 1f

	! walk top level

	lxi HL, end_menu_main
	dlt EA, HL                  ! new did not overrun
	?lxi EA, menu_main          ! ?Not. rewind to first
	lxi HL, menu_main - 1
	dgt EA, HL                  ! did not underrun
	?lxi EA, end_menu_main - 16 ! ?Not. flip to last
	dmov HL, EA
	shld [menu_topptr]
	shld [menu_ptr]
	ret
1:
	! walk at sublevel

	push EA
	lhld [menu_topptr]          ! rangecheck from toplevel
	ldeax [HL+offset_ptr]       ! first record
	dmov BC, EA           
	ldeax [HL+offset_arg]       ! last record
	dmov DE, EA           
	pop EA
	dlt EA, BC           ! below first
	?jr 1f
	dmov EA, DE          ! point to last
1:
	dgt EA, DE           ! above last
	?jr 1f
	dmov EA, BC          ! point to last
1:
	dmov HL, EA
	shld [menu_ptr]
	ret

menu_ok:

	lhld [menu_ptr]
	ldax [HL+offset_type]
	nei A, CFG_NOTYPE
	?jr 1f

	! OK on sublevel

	eqiw LO(kbd_index), 0
	?jmp do_enter_really    ! 123 OK translates to 123 #

	lhld [menu_topptr]      ! else ascend to toplevel
	shld [menu_ptr]
	call menu_enter
	jmp redraw
1:
	! OK on toplevel, descend

	eqiw LO(kbd_index), 0
	?jmp 1f

	ldeax [HL+offset_ptr]   ! 1st subrecord
	dmov HL, EA
	shld [menu_ptr]
	call menu_enter
	jmp redraw

1:
	!  descend to a numbered record

	call get_the_number     ! e.g. 3 OK

	lhld [menu_ptr]
	ldeax [HL+offset_arg]   ! last subrecord
	dmov DE, EA
	ldeax [HL+offset_ptr]   ! 1st subrecord
	dmov HL, EA

	mvi B, 16
	mul B         ! offset (3 * 16) to EA
	dadd EA, HL

	dlt EA, DE
	?dmov EA, DE        ! not < last
	dgt EA, HL
	?dmov EA, HL        ! not > 1st

	dmov HL, EA
	shld [menu_ptr]
	call menu_enter
	jmp redraw

!
!  Entered into new record
!
menu_enter:
	ret

!  Accept current keyboard input buffer as the new value for current
!  configuration record.
!  Adjust to fit in min/max values.

menu_accept:

	mov C, [kbd_index]
	nei C, 0
	?ret

	mviw LO(kbd_index), 0

	lhld [menu_ptr]
	ldax [HL+offset_type]

	! HL has record pointer
	! A has input type
	! C has length of input

	nei A, CFG_NOTYPE
	?ret
	nei A, CFG_DYN
	?ret

	nei A, CFG_EXEC      ! XXX no functionality yet
	?ret

	nei A, CFG_RST
	?jmp menu_accept_666_reset

	nei A, CFG_TAB
	?jmp menu_accept_tab

	nei A, CFG_FOFF
	?jmp menu_accept_f
	nei A, CFG_FREQ
	?jmp menu_accept_f
	nei A, CFG_BYTE
	?jmp menu_accept_byte
	nei A, CFG_DIGIT
	?jmp menu_accept_digit
	nei A, CFG_MSEC
	?jmp menu_accept_msec
	nei A, CFG_SEC
	?jmp menu_accept_sec
	nei A, CFG_MINUTE
	?jmp menu_accept_minute
	nei A, CFG_STRING
	?jmp menu_accept_string

	jmp canada

menu_accept_666_reset:
	eqi C, 3
	?ret
	mov A, [kbd_buffer + 0]
	eqi A, '6'
	?ret
	mov A, [kbd_buffer + 1]
	eqi A, '6'
	?ret
	mov A, [kbd_buffer + 2]
	eqi A, '6'
	?ret

	ldeax [HL+offset_arg]
	push EA
	ret                       ! you asked for it.

menu_accept_tab:
	mov A, [kbd_buffer + 0]
	sui A, '1'
	ldeax [HL+offset_ptr]
	dmov DE, EA
	stax [DE]                 ! XXX rangecheck
	ret

menu_accept_digit:
	mov A, [kbd_buffer]
	sui A, '0'
	ldeax [HL+offset_ptr]
	dmov DE, EA
	stax [DE]                 ! XXX rangecheck
	ret

menu_accept_string:
	ldax [HL+offset_arg]  ! destination length A
	ldeax [HL+offset_ptr]
	dmov DE, EA            ! destination DE
	lxi HL, kbd_buffer   ! source HL, length C
	lta C, A
	?mov C, A           ! cut excess
	sub A, C           ! needed padding
	mov B, A
	jr 2f
1:
	ldax [HL]+
	stax [DE]+ ! bcopy
2:
	dcr C
	?jr 1b
	jr 2f
1:
	mvi A, 0
	stax [DE]+  ! pad with \0
2:
	dcr B
	?jr 1b
	ret

menu_accept_f:
	ldeax [HL+offset_ptr]
	push EA              ! destination of freq
	lxi HL, kbd_buffer    ! length C
	call buf2i             ! HL[C] into BEA
	pop DE
	steax [DE]
	mov A, B
	stax [DE+2]
	ret

menu_accept_byte:
menu_accept_sec:
menu_accept_minute:
	ldeax [HL+offset_ptr]
	push EA                ! destination of byte
	lxi HL, kbd_buffer     ! length in C
	call buf2i
	mov A, EAL
	pop DE
	stax [DE]
	ret

menu_accept_msec:
	ldeax [HL+offset_ptr]
	push EA            ! destination of word
	lxi HL, kbd_buffer ! length C
	call buf2i
	pop DE
	steax [DE]
	ret

draw_menu:

	lhld [menu_ptr]
	lxi EA, offset_title
	dadd EA, HL
	dmov HL, EA         ! title
	mvi C, 8            ! length

	call mbus_send_upper

draw_menu_lower:

	lhld [menu_ptr]
	ldax [HL+offset_type]

	nei A, CFG_NOTYPE
	?jmp draw_kbd_buffer  ! not in submenu, just show any input

	nei A, CFG_RST
	?jmp draw_menu_resets
	nei A, CFG_DYN
	?jmp draw_menu_dyn
	nei A, CFG_TAB
	?jmp draw_menu_tab

	mov B, [kbd_index]
	eqi B, 0
	?jmp draw_kbd_buffer  ! kbd input accepted for below types

	nei A, CFG_EXEC       ! XXX no functionality yet
	?jmp draw_menu_execs

	nei A, CFG_FOFF
	?jmp draw_menu_foff
	nei A, CFG_FREQ
	?jmp draw_menu_freq
	nei A, CFG_BYTE
	?jmp draw_menu_byte
	nei A, CFG_DIGIT
	?jmp draw_menu_digit
	nei A, CFG_MSEC
	?jmp draw_menu_msec
	nei A, CFG_SEC
	?jmp draw_menu_sec
	nei A, CFG_MINUTE
	?jmp draw_menu_minute
	nei A, CFG_STRING
	?jmp draw_menu_string

	jmp canada

draw_menu_execs:
	lxi HL, 1f
	mvi C, 8
	jmp mbus_send_lower
1:
	.asciz "       ?"

draw_menu_string:
	ldax [HL+offset_arg]  ! max length
	mov C, A
	ldeax [HL+offset_ptr]
	dmov HL, EA
	mvi B, 0    ! check nonzero length
1:
	ldax [HL+B]
	nei A, 0    ! not \0.
	?jr 1f
	adi B, 1
	mov A, C
	eqa B, A    ! last.
	?jr 1b
1:
	mov A, B
	mov C, A
	jmp mbus_send_lower

draw_menu_freq:
draw_menu_foff:
	ldeax [HL+offset_ptr]
	dmov HL, EA
	ldeax [HL]
	ldax [HL+2]
	mov B, A
	lxi HL, prt_buffer
	call i2buf
	lxi HL, prt_buffer
	mvi C, 8
	jmp mbus_send_lower

draw_menu_byte:
draw_menu_digit:
	ldeax [HL+offset_ptr]
	dmov HL, EA
	ldeax [HL]
	mvi A, 0
	mov EAH, A
	call format_EA
	lxi HL, prt_buffer + 2
	mvi C, 3
	jmp mbus_send_lower

draw_menu_msec:
	ldeax [HL+offset_ptr]
	dmov HL, EA
	ldeax [HL]
	call format_EA
	lxi HL, prt_buffer + 5 ! "65535 ms"
	mvi A, ' '
	stax [HL]+
	mvi A, 'm'
	stax [HL]+
	mvi A, 's'
	stax [HL]+
	lxi HL, prt_buffer
	mvi C, 8
	jmp mbus_send_lower

draw_menu_minute:
	ldeax [HL+offset_ptr]
	dmov HL, EA
	ldeax [HL]
	mvi A, 0
	mov EAH, A
	call format_EA
	lxi HL, prt_buffer + 5 ! "  255 min"
	mvi A, ' '
	stax [HL]+
	mvi A, 'm'
	stax [HL]+
	mvi A, 'i'
	stax [HL]+
	mvi A, 'n'
	stax [HL]+
	lxi HL, prt_buffer + 2
	mvi C, 7
	jmp mbus_send_lower

draw_menu_sec:
	ldeax [HL+offset_ptr]
	dmov HL, EA
	ldeax [HL]
	mvi A, 0
	mov EAH, A
	call format_EA
	lxi HL, prt_buffer + 5 ! "  255 sec"
	mvi A, ' '
	stax [HL]+
	mvi A, 's'
	stax [HL]+
	mvi A, 'e'
	stax [HL]+
	mvi A, 'c'
	stax [HL]+
	lxi HL, prt_buffer + 2
	mvi C, 7
	jmp mbus_send_lower

draw_menu_resets:
	lxi HL, 1f
	mvi C, 8
	jmp mbus_send_lower
1:
	.asciz "    666?"

draw_menu_dyn:
	lxi EA, 1f
	push EA               ! return 3 lines below
	ldeax [HL+offset_arg]
	push EA               ! stub routine address
	lxi EA, 0             ! prepare default for EAH in case byte value
	ret                   ! jump, result back in EA
1:
	call format_EA
	lxi HL, prt_buffer
	mvi C, 5
	jmp mbus_send_lower

draw_menu_tab:
	ldeax [HL+offset_ptr]  ! pointer to real value
	dmov DE, EA
	mov A, [kbd_buffer]
	sui A, '1'             ! tentative new value '1'...'9' for 0...8
	neiw LO(kbd_index), 0
	?ldax [DE]             ! no pending value, use real one
	mov B, A
	ldeax [HL+offset_arg]  ! get selection list
	dmov HL, EA            ! remember first
	jr 2f
1:
	mvi A, 8              ! length of one string
	eadd EA, A            ! next one please
	dmov DE, EA
	ldax [DE]
	nei A, 0
	?jr 3f             ! no such string, use first one
2:
	dcr B
	?jr 1b
	dmov HL, EA        ! Select this string
3:

	lxi DE, prt_buffer
	mvi C, 0
1:
	ldax [HL]+
	nei A, 0
	?jr 1f
	stax [DE]+
	adi C, 1
	jr 1b
1:
	lxi HL, prt_buffer

	mov B, [kbd_index]
	nei B, 0           ! We are editing.
	?jr 2f             ! ?Not. jump over, "    MIC" displayed"

	! Yes, editing. append blanks to get the value to the left.
1:
	lti C, 8
	?jr 2f
	mvi A, ' '
	stax [DE]+
	adi C, 1
	jr 1b
2:
	jmp mbus_send_lower
!----------------------------------------------------------------------

read_ad0:
	mov A, CR0
	mov EAL, A
	ret
read_ad1:
	mov A, CR1
	mov EAL, A
	ret
read_ad2:
	mov A, CR2
	mov EAL, A
	ret
read_ad3:
	mov A, CR3
	mov EAL, A
	ret

read_ad4:
	mov A, CR3
	mov EAL, A
	ret

read_ad5:
	mov A, CR3
	mov EAL, A
	ret

read_ad6:
	mov A, CR3
	mov EAL, A
	ret

read_ad7:
	mov A, CR3
	mov EAL, A
	ret

read_afc:
	lxi EA, 0 ! XXX use the i8253
	ret

!----------------------------------------------------------------------
! copy defaults from menu

cfg_rst_some:
	lxi HL, menu_main
1:
	push HL
	call 1f               ! reset this submenu
	pop HL
	lxi EA, 16
	dadd EA, HL
	dmov HL, EA
	lxi EA, end_menu_main
	deq EA, HL
	?jr 1b

	jmp 0                      ! reboot
1:
	ldeax [HL+offset_arg]
	dmov BC, EA               ! last record ptr
	ldeax [HL+offset_ptr]
	dmov HL, EA               ! first
1:
	call 1f             ! reset this record
	dmov EA, BC
	dne EA, HL
	?ret                ! did last.
	lxi EA, 16
	dadd EA, HL
	dmov HL, EA
	jr 1b
1:
	ldeax [HL+offset_ptr]   ! address of variable
	dmov DE, EA
	lxi EA, 0
	dne EA, DE
	?ret                    ! has no address
	ldax [HL+offset_type]
	nei A, CFG_FREQ
	?jmp cfg_rst_freq
	nei A, CFG_FOFF
	?jmp cfg_rst_foff
	nei A, CFG_TAB
	?jmp cfg_rst_byte
	nei A, CFG_DIGIT
	?jmp cfg_rst_byte
	nei A, CFG_BYTE
	?jmp cfg_rst_byte
	nei A, CFG_MSEC
	?jmp cfg_rst_msec
	nei A, CFG_SEC
	?jmp cfg_rst_byte
	nei A, CFG_MINUTE
	?jmp cfg_rst_byte
	nei A, CFG_STRING
	?jmp cfg_rst_string
	ret

cfg_rst_freq:
cfg_rst_foff:
	ldax [HL+offset_default+2]
	stax [DE+2]
cfg_rst_msec:
	ldax [HL+offset_default+1]
	stax [DE+1]
cfg_rst_byte:
	ldax [HL+offset_default+0]
	stax [DE+0]
	ret

cfg_rst_string:
	mvi A, 0
	stax [DE]   ! no defaults for strings
	ret

!----------------------------------------------------------------------
! just wipe them out

cfg_rst_mems:
	lxi HL, memories
	lxi EA, end_memories
	mvi A, 0
1:
	stax [HL]+
	deq EA, HL
	?jr 1b

	jmp 0

!----------------------------------------------------------------------
! clear all of ram

cfg_suicide:
	lxi HL, ram
	lxi EA, 0
	mvi A, 0
1:
	stax [HL]+
	deq EA, HL
	?jr 1b

	jmp 0

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!  Convention: Caps in main menu.
!
!  toplevel records hold a pointer to the 1st and to the last (yes, not +1)
!  record on the sublevel. ptr tells where the variable itself lives.
!  arg is misc address. default is encoded into the last 3 free bytes.
!----------------------------------------------------------------------
offset_type = 0
offset_arg  = 1
offset_ptr  = 3
offset_title = 5
offset_default = 5 + 8

#define CFG_REC(tit,ptr,typ,arg) \
  .byte typ; .word arg, ptr; .ascii tit; .byte /* 3 more bytes */
#define CFG_PAD 0,0,0

#define CFG_TOP(tit,ptr) CFG_REC(tit, ptr, CFG_NOTYPE, end_/**/ptr -16) CFG_PAD

#define CFG_SEL(str) _: .ascii str; .align 3, 0
#define CFG_SEL_END .byte 0; .align 4, 0xFF

#define PACK_FREQ(f) LO(f), HI(f), LO(f/65536)

.align 4, 0xFF
!----------------------------------------------------------------------
menu_reserved:
	CFG_REC("XXX    0", cfg_XXX_0, CFG_BYTE, 0) CFG_PAD
	CFG_REC("XXX    1", cfg_XXX_1, CFG_BYTE, 0) CFG_PAD
	CFG_REC("XXX    2", cfg_XXX_2, CFG_BYTE, 0) CFG_PAD
	CFG_REC("XXX    3", cfg_XXX_3, CFG_BYTE, 0) CFG_PAD
end_menu_reserved:
!----------------------------------------------------------------------
menu_hotlist:
	CFG_REC("TX Power", cfg_txpwr,    CFG_BYTE, 100) CFG_PAD
	CFG_REC("DTMF    ", cfg_dtmf_idx, CFG_TAB, 1f) CFG_PAD
	CFG_REC("CCIR    ", cfg_ccir_idx, CFG_TAB, 1f) CFG_PAD
end_menu_hotlist:
1:
	CFG_SEL("OFF")
	CFG_SEL("SEQ 1")
	CFG_SEL("SEQ 2")
	CFG_SEL("SEQ 3")
	CFG_SEL("SEQ 4")
	CFG_SEL("SEQ 5")
	CFG_SEL("SEQ 6")
	CFG_SEL("SEQ 7")
	CFG_SEL("SEQ 8")
	CFG_SEL_END
!----------------------------------------------------------------------
menu_bands:
	CFG_REC("CallFreq", cfg_callfreq,       CFG_FREQ, 0) PACK_FREQ(433500)
	CFG_REC("MostUsed", cfg_my_favorite,    CFG_FREQ, 0) PACK_FREQ(433500)
	CFG_REC("RX Low  ", cfg_rxband_low,     CFG_FREQ, 0) PACK_FREQ(432000)
	CFG_REC("RX High ", cfg_rxband_high,    CFG_FREQ, 0) PACK_FREQ(438000)
	CFG_REC("TX Low  ", cfg_txband_low,     CFG_FREQ, 0) PACK_FREQ(432000)
	CFG_REC("TX High ", cfg_txband_high,    CFG_FREQ, 0) PACK_FREQ(438000)
	CFG_REC("Rptr Low", cfg_rptr_area_low,  CFG_FREQ, 0) PACK_FREQ(434600)
	CFG_REC("Rptr Hi ", cfg_rptr_area_high, CFG_FREQ, 0) PACK_FREQ(435000)
	CFG_REC("Implied ", cfg_freq_implied,   CFG_FREQ, 0) PACK_FREQ(433000)
	CFG_REC("Ch Step ", cfg_chan_step,      CFG_TAB, 1f) 0, 0,0
end_menu_bands:
1:
	CFG_SEL("25")
	CFG_SEL("20")
	CFG_SEL("12")
	CFG_SEL("10")
	CFG_SEL_END
!----------------------------------------------------------------------
menu_duplex:
	CFG_REC("Offset  ", cfg_duplex_off, CFG_FOFF, 0) PACK_FREQ(1600)
	CFG_REC("TX Side ", cfg_duplex_dir, CFG_TAB, 1f) CFG_PAD
end_menu_duplex:
1:
	CFG_SEL("BELOW")
	CFG_SEL("ABOVE")
	CFG_SEL_END
!----------------------------------------------------------------------
menu_parental:
	CFG_REC("LockType", cfg_pin_type, CFG_TAB, 1f) CFG_PAD
	CFG_REC("LockCode", cfg_pin_code, CFG_STRING, SIZE(cfg_pin_code)) CFG_PAD
end_menu_parental:
1:
	CFG_SEL("NONE")
	CFG_SEL("TX")
	CFG_SEL("KEYS")
	CFG_SEL("FULL")
	CFG_SEL_END
!----------------------------------------------------------------------
menu_misc:
	CFG_REC("Mic Gain", cfg_mic_gain,   CFG_DIGIT, 0) 5, 0,0
	CFG_REC("Mic Src ", cfg_mic_src,    CFG_TAB, 1f)  CFG_PAD
	CFG_REC("On Hook ", cfg_onhook_act, CFG_TAB, 2f)  CFG_PAD
	CFG_REC("My Call ", cfg_mycall,     CFG_STRING, SIZE(cfg_mycall)) CFG_PAD
	CFG_REC("MBUS Id ", cfg_my_mbusid,  CFG_STRING, SIZE(cfg_my_mbusid)) CFG_PAD
end_menu_misc:
1:
	CFG_SEL("MIC")
	CFG_SEL("HFMIC")
	CFG_SEL("EXTM")
	CFG_SEL_END
2:
	CFG_SEL("NONE")
	CFG_SEL("SCAN")
	CFG_SEL("CALL")
	CFG_SEL_END
!----------------------------------------------------------------------
menu_volumes:
	CFG_REC("Keyclick", cfg_keyclick, CFG_DIGIT, 0) 1,0,0
	CFG_REC("Alert   ", cfg_alertvol, CFG_DIGIT, 0) CFG_PAD
	CFG_REC("LFU Vol.", cfg_lfu_vol,  CFG_BYTE, 0) 8, 0,0
end_menu_volumes:
!----------------------------------------------------------------------
menu_txtones:
	CFG_REC("Serie  1", cfg_txtone1, CFG_STRING, SIZE(cfg_txtone1)) CFG_PAD
	CFG_REC("Serie  2", cfg_txtone2, CFG_STRING, SIZE(cfg_txtone2)) CFG_PAD
	CFG_REC("Serie  3", cfg_txtone3, CFG_STRING, SIZE(cfg_txtone3)) CFG_PAD
	CFG_REC("Serie  4", cfg_txtone4, CFG_STRING, SIZE(cfg_txtone4)) CFG_PAD
	CFG_REC("Serie  5", cfg_txtone5, CFG_STRING, SIZE(cfg_txtone5)) CFG_PAD
	CFG_REC("Serie  6", cfg_txtone6, CFG_STRING, SIZE(cfg_txtone6)) CFG_PAD
	CFG_REC("Serie  7", cfg_txtone7, CFG_STRING, SIZE(cfg_txtone7)) CFG_PAD
	CFG_REC("Serie  8", cfg_txtone8, CFG_STRING, SIZE(cfg_txtone8)) CFG_PAD
end_menu_txtones:
!----------------------------------------------------------------------
menu_status:
	CFG_REC("RSSI    ", 0, CFG_DYN, read_ad3) CFG_PAD
	CFG_REC("Center  ", 0, CFG_DYN, read_afc) CFG_PAD
	CFG_REC("FSKL    ", 0, CFG_DYN, read_ad0) CFG_PAD
	CFG_REC("BattCurr", 0, CFG_DYN, read_ad1) CFG_PAD
	CFG_REC("BattTemp", 0, CFG_DYN, read_ad2) CFG_PAD
	CFG_REC("TX Power", 0, CFG_DYN, read_ad4) CFG_PAD
	CFG_REC("BattVolt", 0, CFG_DYN, read_ad5) CFG_PAD
	CFG_REC("Temperat", 0, CFG_DYN, read_ad6) CFG_PAD
	CFG_REC("A/D 7   ", 0, CFG_DYN, read_ad7) CFG_PAD
end_menu_status:
!----------------------------------------------------------------------
menu_defaults:
	CFG_REC("RST Some", 0, CFG_RST, cfg_rst_some) CFG_PAD
	CFG_REC("RST Mems", 0, CFG_RST, cfg_rst_mems) CFG_PAD
	CFG_REC("DISASTER", 0, CFG_RST, cfg_suicide)  CFG_PAD
	CFG_REC("AFC Ctrl", cfg_afc,      CFG_BYTE, 0) 0x80, 0,0
	CFG_REC("Dev.Ctrl", cfg_deviation,CFG_BYTE, 0) 0x80, 0,0
	CFG_REC("1st I/F ", cfg_if_freq,  CFG_FREQ, 0) PACK_FREQ(21400)
	CFG_REC("Inj.Side", cfg_if_dir,   CFG_TAB, 1f) 0, 0,0
end_menu_defaults:
1:
	CFG_SEL("ABOVE")
	CFG_SEL("BELOW")
	CFG_SEL_END
!----------------------------------------------------------------------
menu_squelch:
	CFG_REC("SQ Level", cfg_sqlevel, CFG_BYTE, 100) 50, 0,0
	CFG_REC("SQ Hyst.", cfg_sqhyst,  CFG_BYTE, 100) 10, 0,0
	CFG_REC("SQ Delay", cfg_sqdelay, CFG_MSEC, 0) 100, 0,0
	CFG_REC("SQ Tail ", cfg_sqtail,  CFG_MSEC, 0) 100, 0,0
end_menu_squelch:
!----------------------------------------------------------------------
menu_scanner:
	CFG_REC("Sc Delay", cfg_scan_delay,    CFG_SEC, 0) 5, 0,0
	CFG_REC("Patience", cfg_scan_patience, CFG_MINUTE, 0) 5, 0,0
	CFG_REC("StepRate", cfg_step_rate,     CFG_MSEC, 0) 50, 0,0
	CFG_REC("Sc1  Low", cfg_sc1_low,       CFG_FREQ, 0) PACK_FREQ(433400)
	CFG_REC("Sc1 High", cfg_sc1_high,      CFG_FREQ, 0) PACK_FREQ(433600)
	CFG_REC("Sc2  Low", cfg_sc2_low,       CFG_FREQ, 0) PACK_FREQ(434600)
	CFG_REC("Sc2 High", cfg_sc2_high,      CFG_FREQ, 0) PACK_FREQ(435000)
	CFG_REC("Sc3 Fq 0", cfg_sc3_freq_0,    CFG_FREQ, 0) PACK_FREQ(433500)
	CFG_REC("Sc3 Fq 1", cfg_sc3_freq_1,    CFG_FREQ, 0) PACK_FREQ(433525)
	CFG_REC("Sc3 Fq 2", cfg_sc3_freq_2,    CFG_FREQ, 0) PACK_FREQ(433550)
	CFG_REC("Sc3 Fq 3", cfg_sc3_freq_3,    CFG_FREQ, 0) PACK_FREQ(433575)
	CFG_REC("AutoScan", cfg_autoscan_time, CFG_MINUTE, 0) CFG_PAD
end_menu_scanner:
!----------------------------------------------------------------------
menu_rejects:
	CFG_REC("Reject 0", cfg_reject_0, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 1", cfg_reject_1, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 2", cfg_reject_2, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 3", cfg_reject_3, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 4", cfg_reject_4, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 5", cfg_reject_5, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 6", cfg_reject_6, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 7", cfg_reject_7, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 8", cfg_reject_8, CFG_FREQ, 0) PACK_FREQ(0)
	CFG_REC("Reject 9", cfg_reject_9, CFG_FREQ, 0) PACK_FREQ(0)
end_menu_rejects:
!----------------------------------------------------------------------
menu_main:
	CFG_TOP("HOTLIST ",menu_hotlist)
	CFG_TOP("SQUELCH ",menu_squelch)
	CFG_TOP("SCANNER ",menu_scanner)
	CFG_TOP("REJECTS ",menu_rejects)
	CFG_TOP("VOLUMES ",menu_volumes)
	CFG_TOP("DUPLEX  ",menu_duplex)
	CFG_TOP("MISC CFG",menu_misc)
	CFG_TOP("BAND CFG",menu_bands)
	CFG_TOP("TX TONES",menu_txtones)
	CFG_TOP("PARENTAL",menu_parental)
	CFG_TOP("DEFAULTS",menu_defaults)
	CFG_TOP("RESERVED",menu_reserved)
	CFG_TOP("STATUS  ",menu_status)
end_menu_main:
!----------------------------------------------------------------------
!----------------------------------------------------------------------
#include "mbus.asm" /* get the text */

handset_init:
	call mbus_constmsg; .ascii HS_ID, MBUSID, "f", VERSION_2; .byte 0
	call mbus_constmsg; .ascii HS_ID, MBUSID, "d", VERSION_1; .byte 0
	call mbus_constmsg; .ascii HS_ID, MBUSID, "s", "99"; .byte 0
	ret

!    0 "HSN2" "...." "v" "." \4         e.g. volume setting 0..9
!    0 "HSN2" "...." "l" "sT" \4        e.g. markers SERV=off, ROAM=on

mbus_sendvol:
	call prep_tx_msg

	mvi A, 'v'
	stax [DE]+

	mov A, [volume]
	gti A, 9
	?jr 1f
	mvi A, '1'
	stax [DE]+

	mov A, [volume]
	sui A, 10
1:
	adi A, '0'
	stax [DE]+

	jmp append_tail

mbus_sendrssi:
	call prep_tx_msg

	mvi A, 's'
	stax [DE]+

	mov A, [rssi_peak]
	lxi EA, 0
	mov EAL, A
	mvi B, 10
	div B

	mov A, EAL
	adi A, '0'
	nei A, '0'
	?mvi A, ' '
	stax [DE]+

	mov A, B
	adi A, '0'
	stax [DE]+

	jmp append_tail

mbus_update_lights:
	call prep_tx_msg

	mvi A, 'l'
	stax [DE]+

	mvi A, 'F'
	oniw LO(kbd_flags), SHIFT
	?mvi A, 'f'
	stax [DE]+

	mvi A, 'A'
	oniw LO(kbd_flags), ALPHA
	?mvi A, 'a'
	stax [DE]+

	mvi A, 'K'
	oniw LO(kbd_flags), KEYLOCK
	?mvi A, 'k'
	stax [DE]+

	jmp append_tail

mbus_send_tones:
	call prep_tx_msg
	mvi A, 'b'
	jmp mbus_send_stuff

mbus_send_upper:
	call prep_tx_msg
	mvi A, 'd'
	jmp mbus_send_stuff

mbus_send_lower:
	call prep_tx_msg
	mvi A, 'f'
	jmp mbus_send_stuff

prep_tx_msg:
	lxi DE, mbus_txmsg
	mvi A, 'H'
	stax [DE]+
	mvi A, 'S'
	stax [DE]+
	mvi A, 'N'
	stax [DE]+
	mvi A, '2'
	stax [DE]+
	mvi A, 'T'
	stax [DE]+
	mvi A, 'M'
	stax [DE]+
	mvi A, 'F'
	stax [DE]+
	mvi A, '1'
	stax [DE]+
	ret

mbus_send_stuff:
	stax [DE]+
	jmp append_data

1:
	ldax [HL]+
	stax [DE]+
append_data:
	dcr C
	?jr 1b       ! loop or FALLTHRU

append_tail:
	mvi A, 4
	stax [DE]+
	mvi A, 0
	stax [DE]+

	jmp mbus_send

!----------------------------------------------------------------------

mbus_newmsg:

	ldax [HL]+
	eqi A, 'A'
	?ret
	ldax [HL]+
	eqi A, 'N'
	?ret
	ldax [HL]+
	eqi A, 'Y'
	?ret
	ldax [HL]+
	eqi A, '1'
	?ret

	ldax [HL]+               ! sender at [HL] now
	nei A, 0xFF
	?ret
	ldax [HL]+
	nei A, 0xFF
	?ret
	ldax [HL]+
	nei A, 0xFF
	?ret
	ldax [HL]+
	nei A, 0xFF
	?ret

	ldax [HL]+     ! now after addresses, length at C, \4 not included

	nei A, 'M'
	?jmp msg_key_make
	nei A, 'R'
	?jmp msg_key_repeat

	ret ! hmph. dunno what it is.

!----------------------------------------------------------------------
! HL points to message data after command designator character.
! Length of data in C
! e.g. HL->"foobar", C=6

msg_key_make: !  XXX process N keys, not just one
	ldax [HL]+
	mvi B, 0
	jmp got_key

msg_key_repeat: !  XXX process N keys, not just one
	ldax [HL]+
	mvi B, 1
	jmp got_key

!----------------------------------------------------------------------

	.ascii "\n\n\n\n@(#)"
version:
	.ascii VERSION_1, "  ", VERSION_2
	.byte 0

TheEnd:

